0    REM *** TITLE SCREEN ***
1    CLS
5    CHAR 9,  03 03 1F 3F 3F 3F F3 F3
6    CHAR 10, C0 C0 F8 FC FC FC CF CF
7    CHAR 11, FF FF 3F 3F 3F 1F 03 03
8    CHAR 12, FF FF FC FC FC F8 C0 C0
10   COLOR 2, 9, 2
11   COLOR 7, 8, 2
12   COLOR 8, 5, 2
13   COLOR 9, 16, 2
14   COLOR 10, 11, 2
15   COLOR 11, 14, 2
16   COLOR 12, 7, 2
20   PRINT"             "+CHR$(9)+CHR$(10)
21   PRINT"             "+CHR$(11)+CHR$(12)
22   PRINT
23   PRINT
24   PRINT
25   PRINT
26   PRINT"          KAPOOKA"
27   PRINT
28   PRINT
29   PRINT
30   PRINT
31   PRINT"   BY PAUL RAHME, 2009-10"
32   PRINT
33   PRINT
34   PRINT
35   PRINT" ENTER START LEVEL (1-11):"
40   INPUT K
41   IF K < 1 THEN K = 1
42   IF K > 11 THEN K = 11
43   REM *** DATA LINE NUMBER (+25 FOR NEXT LEVEL) ***
44   N = 6000 + ((K-1)*25)

50   REM *** SET UP CHARS ***
52   PRINT"SETTING UP GRAPHICS..."
60   REM 0 = BLANK, 1 = STATIC BLOCK, 8 = MAIN CHAR
61   REM 16 = PUSHABLE BLOCK, 69 = EXIT
62   CHAR 0,  18 66 42 81 81 42 66 18
63   CHAR 1,  18 7E 7E FF FF 7E 7E 18
64   CHAR 2,  FF FF FF FF FF FF FF FF
65   CHAR 8,  18 7E 7E DB FF 7E 7E 18
66   CHAR 16, 18 7E 7E FF FF 7E 7E 18
80   COLOR 1, 5, 2
81   COLOR 2, 9, 2
82   COLOR 3, 3, 2

100  REM *** LEVEL MEMORY POINTER ***
110  L = 350

300  PRINT"LOADING DATA..."
302  POKE 1195,0
303  POKE 1197,0
304  GOSUB N
306  READ W,H
310  IF W = 0 THEN 9000
311  IF H = 0 THEN 9000
312  W = W+2
313  H = H+2
314  O = (32-W) / 2
315  P = (23-H) / 2

320  REM *** CREATE BORDER ***
322  FOR A = 0 TO (W-1)
324  POKE(L + A),2
326  POKE(L + ((H-1)*W) + A),2
328  NEXT A
330  FOR B = 0 TO (H-1)
332  POKE(L + (B*W)),2
334  POKE(L + (B*W) + (W-1)),2
336  NEXT B

350  PRINT"SETTING UP BOARD..."
360  FOR B = 1 TO (H-2)
362  FOR A = 1 TO (W-2)
364  READ C
366  POKE(L + (B*W) + A),C
368  IF C = 8 THEN Z = (B*W)+A
REM 370  PRINT L + (B*W) + A, PEEK(L+(B*W)+A)
372  NEXT A
374  NEXT B

450  CLS
455  REM *** PLOT LEVEL NO ***
456  A = K
457  IF A < 10 THEN GOTO 465
458  IF A < 20 THEN GOTO 463
459  PLOT 15,P-1,50
460  A = A-20
461  GOTO 465
463  PLOT 15,P-1,49
464  A = A-10
465  PLOT 16,P-1,48+A

470  REM *** PLOT BOARD ***
472  FOR B = 0 TO (H-1)
473  FOR A = 0 TO (W-1)
474  PLOT A+O, B+P, PEEK(L+(B*W)+A)
475  NEXT A
476  NEXT B

480  REM *** PLOT MAIN CHAR ***
481  POKE 218,6
485  A = Z
486  GOSUB 5000
487  PLOT X, Y, 8

500  REM *** MAIN GAME LOOP ***
REM 502  POKE 218,6
510  IF JOY(1) = 3 THEN GOTO 550
512  IF JOY(1) = 7 THEN GOTO 650
514  IF JOY(1) = 1 THEN GOTO 750
516  IF JOY(1) = 5 THEN GOTO 850
518  IF JOY(3) <> 0 THEN GOTO 1000
520  GOTO 510

550  REM *** PRESSED RIGHT ***
552  B = PEEK(L+Z+1)
REM 554  PRINT L+Z,L+Z+1,B
555  IF B = 0 OR B = 69 THEN GOTO 570
557  IF B = 16 AND PEEK(L+Z+2) = 0 THEN GOTO 600
561  GOTO 500

570  REM *** MOVE RIGHT ***
572  Z = Z+1
574  A = Z
576  GOSUB 5000
580  PLOT X,Y,8
581  PLOT X-1,Y,0
585  IF PEEK(L+Z) = 69 THEN GOTO 1100
590  GOTO 500

600  REM *** PUSH BLOCK RIGHT ***
605  A = Z+2
REM 608  PRINT L+A,PEEK(L+A-1),PEEK(L+A)
615  GOSUB 5000
620  PLOT X,Y,16
625  PLOT X-1,Y,0
628  POKE L+A, 16
629  POKE L+A-1, 0
630  A = A+1
640  IF PEEK(L+A) = 0 THEN GOTO 615
645  GOTO 570

650  REM *** PRESSED LEFT ***
652  B = PEEK(L+Z-1)
REM 654  PRINT L+Z,L+Z-1,B
655  IF B = 0 OR B = 69 THEN GOTO 670
657  IF B = 16 AND PEEK(L+Z-2) = 0 THEN GOTO 700
661  GOTO 500

670  REM *** MOVE LEFT ***
672  Z = Z-1
674  A = Z
676  GOSUB 5000
680  PLOT X,Y,8
681  PLOT X+1,Y,0
685  IF PEEK(L+Z) = 69 THEN GOTO 1100
690  GOTO 500

700  REM *** PUSH BLOCK LEFT ***
705  A = Z-2
REM 708  PRINT L+A,PEEK(L+A-1),PEEK(L+A)
715  GOSUB 5000
720  PLOT X,Y,16
725  PLOT X+1,Y,0
728  POKE L+A, 16
729  POKE L+A+1, 0
730  A = A-1
740  IF PEEK(L+A) = 0 THEN GOTO 715
745  GOTO 670

750  REM *** PRESSED DOWN ***
752  B = PEEK(L+Z+W)
REM 754 PRINT L+Z,L+Z+W,B
755  IF B = 0 OR B = 69 THEN GOTO 770
757  IF B = 16 AND PEEK(L+Z+(W*2)) = 0 THEN GOTO 800
761  GOTO 500

770  REM *** MOVE DOWN ***
772  Z = Z+W
774  A = Z
776  GOSUB 5000
780  PLOT X,Y,8
781  PLOT X,Y-1,0
785  IF PEEK(L+Z) = 69 THEN GOTO 1100
790  GOTO 500

800  REM *** PUSH BLOCK DOWN ***
805  A = Z+(W*2)
REM 808  PRINT L+A,PEEK(L+A+W),PEEK(L+A)
815  GOSUB 5000
820  PLOT X,Y,16
825  PLOT X,Y-1,0
828  POKE L+A, 16
829  POKE L+A-W, 0
830  A = A+W
840  IF PEEK(L+A) = 0 THEN GOTO 815
845  GOTO 770

850  REM *** PRESSED UP ***
852  B = PEEK(L+Z-W)
REM 854  PRINT L+Z,L+Z-W,B
855  IF B = 0 OR B = 69 THEN GOTO 870
857  IF B = 16 AND PEEK(L+Z-(W*2)) = 0 THEN GOTO 900
861  GOTO 500

870  REM *** MOVE UP ***
872  Z = Z-W
874  A = Z
876  GOSUB 5000
880  PLOT X,Y,8
881  PLOT X,Y+1,0
885  IF PEEK(L+Z) = 69 THEN GOTO 1100
890  GOTO 500

900  REM *** PUSH BLOCK UP ***
905  A = Z-(W*2)
REM 908  PRINT L+A,PEEK(L+A-W),PEEK(L+A)
915  GOSUB 5000
920  PLOT X,Y,16
925  PLOT X,Y+1,0
928  POKE L+A, 16
929  POKE L+A+W, 0
930  A = A-W
940  IF PEEK(L+A) = 0 THEN GOTO 915
945  GOTO 870

1000 REM *** RESET CURRENT BOARD ***
1010 PRINT"RESTARTING..."
1020 REM RESET DATA OFFSET TO JUST AFTER W,H
1030 A = 4
1031 IF W > 9 THEN A = A+1
1032 IF H > 9 THEN A = A+1
1035 POKE 1197,A
1040 GOTO 350

1100 REM *** LEVEL COMPLETE, LOAD NEXT LEVEL ***
1110 N = N+25
1120 K = K+1
1140 GOTO 300



4999 END

5000 REM *** CONVERT MEM POS (A) TO PLOT POS (X,Y) ***
5010 Y = INT(A/W)
5015 X = A - (Y*W) + O
5020 Y = Y+P
REM 5025 PRINT TAB(2);A,X,Y
5100 RETURN

6000 REM *** BOARD DATA ***

6010 DATA6,3
6011 DATA0,0,0,16,16,16
6012 DATA16,0,16,0,16,16
6013 DATA8,16,0,0,0,69
6014 RETURN

6025 DATA8,8
6026 DATA16,16,0,16,16,16,16,0
6027 DATA0,16,16,0,0,16,0,0
6028 DATA16,16,0,16,16,0,16,16
6029 DATA16,0,16,16,0,16,0,16
6030 DATA16,16,16,0,0,16,0,16
6031 DATA0,8,16,16,69,0,0,16
6032 DATA16,16,16,16,16,0,0,16
6033 DATA16,16,16,16,16,0,16,16
6034 RETURN

6050 DATA9,4
6051 DATA8,16,0,16,0,16,0,0,16
6052 DATA16,0,16,0,0,16,16,16,0
6053 DATA0,16,0,16,16,0,0,16,69
6054 DATA0,0,0,16,0,0,0,0,16
6055 RETURN

6075 DATA8,7
6076 DATA8,16,0,16,16,16,16,16
6077 DATA16,16,16,0,16,16,16,16
6078 DATA0,0,0,16,0,0,0,16
6079 DATA16,16,16,0,16,16,16,69
6080 DATA0,0,0,0,16,16,0,16
6081 DATA0,16,16,16,0,16,0,16
6082 DATA16,0,16,0,0,0,0,16
6083 RETURN

6100 DATA6,5
6101 DATA0,16,0,16,0,16
6102 DATA8,0,16,0,16,0
6103 DATA0,16,0,16,0,16
6104 DATA16,0,16,0,16,69
6105 DATA0,16,0,16,0,16
6106 RETURN

6125 DATA10,10
6126 DATA0,16,0,16,0,16,0,16,16,0
6127 DATA16,69,16,0,16,0,16,16,0,16
6128 DATA0,16,0,16,0,16,0,16,0,16
6129 DATA16,0,16,0,16,0,0,16,0,0
6130 DATA0,16,0,16,0,16,0,16,0,16
6131 DATA0,16,0,0,16,0,16,0,16,0
6132 DATA16,0,16,16,0,0,16,16,0,0
6133 DATA0,16,16,0,0,16,16,0,16,0
6134 DATA0,0,0,16,0,16,8,0,16,16
6135 DATA16,0,0,16,0,16,0,16,0,16
6136 RETURN

6150 DATA10,8
6151 DATA0,0,0,16,0,0,0,16,16,16
6152 DATA16,0,16,16,16,16,0,0,16,16
6153 DATA0,16,16,16,8,16,0,16,16,16
6154 DATA0,0,0,16,16,0,0,0,16,16
6155 DATA16,0,16,0,16,16,16,16,16,16
6156 DATA16,16,0,0,0,0,16,0,16,16
6157 DATA16,16,0,16,16,0,16,16,0,69
6158 DATA16,0,0,0,0,0,0,16,0,16
6159 RETURN

6175 DATA8,9
6176 DATA16,16,0,0,0,16,0,16
6177 DATA16,16,0,16,0,0,16,16
6178 DATA0,0,16,0,16,0,0,0
6179 DATA16,16,0,0,16,16,0,0
6180 DATA0,0,16,0,16,16,0,16
6181 DATA0,16,0,16,0,16,16,0
6182 DATA16,0,16,0,16,0,16,16
6183 DATA0,0,0,16,0,69,16,8
6184 DATA16,0,16,16,16,16,16,16
6185 RETURN

6200 DATA9,11
6201 DATA0,0,16,0,16,0,16,0,16
6202 DATA0,16,0,16,0,16,0,0,0
6203 DATA0,0,0,0,0,16,16,0,0
6204 DATA16,8,16,0,16,16,0,0,16
6205 DATA0,0,0,16,16,0,16,16,0
6206 DATA0,16,0,16,16,16,0,16,0
6207 DATA16,0,0,16,0,0,16,0,0
6208 DATA16,0,16,16,16,16,0,16,16
6209 DATA0,0,16,0,16,0,16,16,0
6210 DATA16,16,16,16,0,16,0,16,16
6211 DATA16,16,16,16,16,69,0,16,16
6212 RETURN

6225 DATA7,10
6226 DATA1,1,1,1,0,0,0
6227 DATA8,1,1,0,0,0,0
6228 DATA0,1,0,16,0,1,0
6229 DATA0,1,69,0,16,0,0
6230 DATA0,1,1,0,1,1,0
6231 DATA0,0,16,16,16,0,0
6232 DATA0,0,0,0,1,1,16
6233 DATA0,1,1,16,16,0,0
6234 DATA0,1,1,0,16,0,0
6235 DATA0,0,16,0,0,0,1
6236 RETURN

6250 DATA10,10
6251 DATA1,16,0,16,0,0,0,16,0,0
6252 DATA0,16,16,16,16,0,16,16,0,16
6253 DATA16,0,16,0,0,0,16,0,0,0
6254 DATA0,16,0,16,0,16,0,16,0,0
6255 DATA0,0,16,16,16,16,16,0,0,0
6256 DATA0,16,16,16,0,69,0,16,0,0
6257 DATA0,16,0,0,16,16,16,16,16,16
6258 DATA0,0,16,16,16,0,16,0,0,1
6259 DATA0,16,8,16,16,16,0,16,1,1
6260 DATA0,16,0,0,16,0,0,16,1,1
6261 RETURN

6275 DATA0,0



9000 REM *** END SEQUENCE ***
9001 CLS
9002 PRINT
9003 PRINT
9004 PRINT"      CONGRATULATIONS!"
9005 PRINT
9006 PRINT
9007 PRINT
9008 PRINT"    ALL LEVELS COMPLETED"
9009 PRINT
9010 PRINT
9011 PRINT
9012 PRINT
9013 PRINT"             ";CHR$(8)
9014 PRINT
9015 PRINT
9016 PRINT
9017 PRINT
9018 PRINT
9019 PRINT
9020 PRINT

9050 CHAR 8, 18 7E 7E DD FF 7E 7E 18
9051 CHAR 8, 18 7E 7E DD FF 7E 66 18
9052 CHAR 8, 18 7E 7E BB FF 7E 7E 18
9053 CHAR 8, 18 7E 7E BB FF 7E 66 18
9054 GOTO 9050
